import { Injectable } from '@nestjs/common';
import { BaseUpdateManager } from 'src/core/modules/domain/usecase/managers/base-update.manager';
import { NewsEntity } from '../../entities/news.entity';
import { NewsModel } from '../../../data/models/news.model';
import { NewsUpdatedEvent } from '../../entities/event/news-updated.event';
import {
  EventTopics,
  columnUniques,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';

@Injectable()
export class UpdateNewsManager extends BaseUpdateManager<NewsEntity> {
  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get uniqueColumns(): columnUniques[] {
    return [];
  }

  get entityTarget(): any {
    return NewsModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: NewsUpdatedEvent,
      },
    ];
  }
}
